#define CASE(K,V) case K: return V;
#if __APPLE__
enum {
    kVK_ANSI_A                    = 0x00,
    kVK_ANSI_S                    = 0x01,
    kVK_ANSI_D                    = 0x02,
    kVK_ANSI_F                    = 0x03,
    kVK_ANSI_H                    = 0x04,
    kVK_ANSI_G                    = 0x05,
    kVK_ANSI_Z                    = 0x06,
    kVK_ANSI_X                    = 0x07,
    kVK_ANSI_C                    = 0x08,
    kVK_ANSI_V                    = 0x09,
    kVK_ANSI_B                    = 0x0B,
    kVK_ANSI_Q                    = 0x0C,
    kVK_ANSI_W                    = 0x0D,
    kVK_ANSI_E                    = 0x0E,
    kVK_ANSI_R                    = 0x0F,
    kVK_ANSI_Y                    = 0x10,
    kVK_ANSI_T                    = 0x11,
    kVK_ANSI_1                    = 0x12,
    kVK_ANSI_2                    = 0x13,
    kVK_ANSI_3                    = 0x14,
    kVK_ANSI_4                    = 0x15,
    kVK_ANSI_6                    = 0x16,
    kVK_ANSI_5                    = 0x17,
    kVK_ANSI_Equal                = 0x18,
    kVK_ANSI_9                    = 0x19,
    kVK_ANSI_7                    = 0x1A,
    kVK_ANSI_Minus                = 0x1B,
    kVK_ANSI_8                    = 0x1C,
    kVK_ANSI_0                    = 0x1D,
    kVK_ANSI_RightBracket         = 0x1E,
    kVK_ANSI_O                    = 0x1F,
    kVK_ANSI_U                    = 0x20,
    kVK_ANSI_LeftBracket          = 0x21,
    kVK_ANSI_I                    = 0x22,
    kVK_ANSI_P                    = 0x23,
    kVK_ANSI_L                    = 0x25,
    kVK_ANSI_J                    = 0x26,
    kVK_ANSI_Quote                = 0x27,
    kVK_ANSI_K                    = 0x28,
    kVK_ANSI_Semicolon            = 0x29,
    kVK_ANSI_Backslash            = 0x2A,
    kVK_ANSI_Comma                = 0x2B,
    kVK_ANSI_Slash                = 0x2C,
    kVK_ANSI_N                    = 0x2D,
    kVK_ANSI_M                    = 0x2E,
    kVK_ANSI_Period               = 0x2F,
    kVK_ANSI_Grave                = 0x32,
    kVK_ANSI_KeypadDecimal        = 0x41,
    kVK_ANSI_KeypadMultiply       = 0x43,
    kVK_ANSI_KeypadPlus           = 0x45,
    kVK_ANSI_KeypadClear          = 0x47,
    kVK_ANSI_KeypadDivide         = 0x4B,
    kVK_ANSI_KeypadEnter          = 0x4C,
    kVK_ANSI_KeypadMinus          = 0x4E,
    kVK_ANSI_KeypadEquals         = 0x51,
    kVK_ANSI_Keypad0              = 0x52,
    kVK_ANSI_Keypad1              = 0x53,
    kVK_ANSI_Keypad2              = 0x54,
    kVK_ANSI_Keypad3              = 0x55,
    kVK_ANSI_Keypad4              = 0x56,
    kVK_ANSI_Keypad5              = 0x57,
    kVK_ANSI_Keypad6              = 0x58,
    kVK_ANSI_Keypad7              = 0x59,
    kVK_ANSI_Keypad8              = 0x5B,
    kVK_ANSI_Keypad9              = 0x5C
};

/* keycodes for keys that are independent of keyboard layout*/
enum {
    kVK_Return                    = 0x24,
    kVK_Tab                       = 0x30,
    kVK_Space                     = 0x31,
    kVK_Delete                    = 0x33,
    kVK_Escape                    = 0x35,
    kVK_Command                   = 0x37,
    kVK_Shift                     = 0x38,
    kVK_CapsLock                  = 0x39,
    kVK_Option                    = 0x3A,
    kVK_Control                   = 0x3B,
    kVK_RightShift                = 0x3C,
    kVK_RightOption               = 0x3D,
    kVK_RightControl              = 0x3E,
    kVK_Function                  = 0x3F,
    kVK_F17                       = 0x40,
    kVK_VolumeUp                  = 0x48,
    kVK_VolumeDown                = 0x49,
    kVK_Mute                      = 0x4A,
    kVK_F18                       = 0x4F,
    kVK_F19                       = 0x50,
    kVK_F20                       = 0x5A,
    kVK_F5                        = 0x60,
    kVK_F6                        = 0x61,
    kVK_F7                        = 0x62,
    kVK_F3                        = 0x63,
    kVK_F8                        = 0x64,
    kVK_F9                        = 0x65,
    kVK_F11                       = 0x67,
    kVK_F13                       = 0x69,
    kVK_F16                       = 0x6A,
    kVK_F14                       = 0x6B,
    kVK_F10                       = 0x6D,
    kVK_F12                       = 0x6F,
    kVK_F15                       = 0x71,
    kVK_Help                      = 0x72,
    kVK_Home                      = 0x73,
    kVK_PageUp                    = 0x74,
    kVK_ForwardDelete             = 0x75,
    kVK_F4                        = 0x76,
    kVK_End                       = 0x77,
    kVK_F2                        = 0x78,
    kVK_PageDown                  = 0x79,
    kVK_F1                        = 0x7A,
    kVK_LeftArrow                 = 0x7B,
    kVK_RightArrow                = 0x7C,
    kVK_DownArrow                 = 0x7D,
    kVK_UpArrow                   = 0x7E
};

inline kKey convert_key(int key)
{
    switch(key)
    {
    CASE(kVK_ANSI_A, kKey::KeyA);
    CASE(kVK_ANSI_S, kKey::KeyS);
    CASE(kVK_ANSI_D, kKey::KeyD);
    CASE(kVK_ANSI_F, kKey::KeyF);
    CASE(kVK_ANSI_H, kKey::KeyH);
    CASE(kVK_ANSI_G, kKey::KeyG);
    CASE(kVK_ANSI_Z, kKey::KeyZ);
    CASE(kVK_ANSI_X, kKey::KeyX);
    CASE(kVK_ANSI_C, kKey::KeyC);
    CASE(kVK_ANSI_V, kKey::KeyV);
    CASE(kVK_ANSI_B, kKey::KeyB);
    CASE(kVK_ANSI_Q, kKey::KeyQ);
    CASE(kVK_ANSI_W, kKey::KeyW);
    CASE(kVK_ANSI_E, kKey::KeyE);
    CASE(kVK_ANSI_R, kKey::KeyR);
    CASE(kVK_ANSI_Y, kKey::KeyY);
    CASE(kVK_ANSI_T, kKey::KeyT);
    CASE(kVK_ANSI_1, kKey::Key1);
    CASE(kVK_ANSI_2, kKey::Key2);
    CASE(kVK_ANSI_3, kKey::Key3);
    CASE(kVK_ANSI_4, kKey::Key4);
    CASE(kVK_ANSI_6, kKey::Key6);
    CASE(kVK_ANSI_5, kKey::Key5);
    CASE(kVK_ANSI_Equal, kKey::Unknown);
    CASE(kVK_ANSI_9, kKey::Key9);
    CASE(kVK_ANSI_7, kKey::Key7);
    CASE(kVK_ANSI_Minus, kKey::Unknown);
    CASE(kVK_ANSI_8, kKey::Key8);
    CASE(kVK_ANSI_0, kKey::Key0);
    CASE(kVK_ANSI_RightBracket, kKey::KeyBracketRight);
    CASE(kVK_ANSI_O, kKey::KeyO);
    CASE(kVK_ANSI_U, kKey::KeyU);
    CASE(kVK_ANSI_LeftBracket, kKey::KeyBracketLeft);
    CASE(kVK_ANSI_I, kKey::KeyI);
    CASE(kVK_ANSI_P, kKey::KeyP);
    CASE(kVK_ANSI_L, kKey::KeyL);
    CASE(kVK_ANSI_J, kKey::KeyJ);
    CASE(kVK_ANSI_Quote, kKey::Unknown);
    CASE(kVK_ANSI_K, kKey::KeyK);
    CASE(kVK_ANSI_Semicolon, kKey::Unknown);
    CASE(kVK_ANSI_Backslash, kKey::Unknown);
    CASE(kVK_ANSI_Comma, kKey::Unknown);
    CASE(kVK_ANSI_Slash, kKey::Unknown);
    CASE(kVK_ANSI_N, kKey::KeyN);
    CASE(kVK_ANSI_M, kKey::KeyM);
    CASE(kVK_ANSI_Period, kKey::Unknown);
    CASE(kVK_ANSI_Grave, kKey::Unknown);
    CASE(kVK_ANSI_KeypadDecimal, kKey::Unknown);
    CASE(kVK_ANSI_KeypadMultiply, kKey::Unknown);
    CASE(kVK_ANSI_KeypadPlus, kKey::Unknown);
    CASE(kVK_ANSI_KeypadClear, kKey::Unknown);
    CASE(kVK_ANSI_KeypadDivide, kKey::Unknown);
    CASE(kVK_ANSI_KeypadEnter, kKey::Unknown);
    CASE(kVK_ANSI_KeypadMinus, kKey::Unknown);
    CASE(kVK_ANSI_KeypadEquals, kKey::Unknown);
    CASE(kVK_ANSI_Keypad0, kKey::Unknown);
    CASE(kVK_ANSI_Keypad1, kKey::Unknown);
    CASE(kVK_ANSI_Keypad2, kKey::Unknown);
    CASE(kVK_ANSI_Keypad3, kKey::Unknown);
    CASE(kVK_ANSI_Keypad4, kKey::Unknown);
    CASE(kVK_ANSI_Keypad5, kKey::Unknown);
    CASE(kVK_ANSI_Keypad6, kKey::Unknown);
    CASE(kVK_ANSI_Keypad7, kKey::Unknown);
    CASE(kVK_ANSI_Keypad8, kKey::Unknown);
    CASE(kVK_ANSI_Keypad9, kKey::Unknown);
    CASE(kVK_Return, kKey::KeyEnter);
    CASE(kVK_Tab, kKey::KeyTab);
    CASE(kVK_Space, kKey::Unknown);
    CASE(kVK_Delete, kKey::KeyDel);
    CASE(kVK_Escape, kKey::Unknown);
    CASE(kVK_Command, kKey::KeyCtrl);
    CASE(kVK_Shift, kKey::KeyShift);
    CASE(kVK_CapsLock, kKey::Unknown);
    CASE(kVK_Option, kKey::Unknown);
    CASE(kVK_Control, kKey::Unknown);
    CASE(kVK_RightShift, kKey::Unknown);
    CASE(kVK_RightOption, kKey::Unknown);
    CASE(kVK_RightControl, kKey::Unknown);
    CASE(kVK_Function, kKey::Unknown);
    CASE(kVK_F17, kKey::Unknown);
    CASE(kVK_VolumeUp, kKey::Unknown);
    CASE(kVK_VolumeDown, kKey::Unknown);
    CASE(kVK_Mute, kKey::Unknown);
    CASE(kVK_F18, kKey::KeyF18);
    CASE(kVK_F19, kKey::KeyF19);
    CASE(kVK_F20, kKey::KeyF20);
    CASE(kVK_F5, kKey::KeyF5);
    CASE(kVK_F6, kKey::KeyF6);
    CASE(kVK_F7, kKey::KeyF7);
    CASE(kVK_F3, kKey::KeyF3);
    CASE(kVK_F8, kKey::KeyF8);
    CASE(kVK_F9, kKey::KeyF9);
    CASE(kVK_F11, kKey::KeyF11);
    CASE(kVK_F13, kKey::KeyF13);
    CASE(kVK_F16, kKey::KeyF16);
    CASE(kVK_F14, kKey::KeyF14);
    CASE(kVK_F10, kKey::KeyF10);
    CASE(kVK_F12, kKey::KeyF12);
    CASE(kVK_F15, kKey::KeyF15);
    CASE(kVK_Help, kKey::Unknown);
    CASE(kVK_Home, kKey::Unknown);
    CASE(kVK_PageUp, kKey::Unknown);
    CASE(kVK_ForwardDelete, kKey::Unknown);
    CASE(kVK_F4, kKey::Unknown);
    CASE(kVK_End, kKey::Unknown);
    CASE(kVK_F2, kKey::Unknown);
    CASE(kVK_PageDown, kKey::Unknown);
    CASE(kVK_F1, kKey::Unknown);
    CASE(kVK_LeftArrow, kKey::Unknown);
    CASE(kVK_RightArrow, kKey::Unknown);
    CASE(kVK_DownArrow, kKey::Unknown);
    CASE(kVK_UpArrow, kKey::Unknown);
    default: 
        return kKey::Unknown;
    }
}
#elif __WIN__
inline kKey convert_key(int key)
{
    static auto KL = GetKeyboardLayout(0);
    if (key == (VkKeyScanA('[') & 0xFF))
        return kKey::KeyBracketLeft;
    if (key == (VkKeyScanA(']') & 0xFF))
        return kKey::KeyBracketRight;
    switch(key)
    {
    CASE(VK_LBUTTON, kKey::Unknown);
    CASE(VK_RBUTTON, kKey::Unknown);
    CASE(VK_CANCEL, kKey::Unknown);
    CASE(VK_MBUTTON, kKey::Unknown);
    CASE(VK_XBUTTON1, kKey::Unknown);
    CASE(VK_XBUTTON2, kKey::Unknown);
    CASE(VK_BACK, kKey::Unknown);
    CASE(VK_TAB, kKey::KeyTab);
    CASE(VK_CLEAR, kKey::Unknown);
    CASE(VK_RETURN, kKey::Unknown);
    CASE(VK_SHIFT, kKey::KeyShift);
    CASE(VK_CONTROL, kKey::KeyCtrl);
    CASE(VK_MENU, kKey::KeyAlt);
    CASE(VK_PAUSE, kKey::Unknown);
    CASE(VK_CAPITAL, kKey::Unknown);
    CASE(VK_KANA, kKey::Unknown);
    //CASE(VK_HANGEUL, kKey::Unknown); // same as VK_KANA
    //CASE(VK_HANGUL, kKey::Unknown);  // same as VK_KANA
    CASE(VK_JUNJA, kKey::Unknown);
    CASE(VK_FINAL, kKey::Unknown);
    CASE(VK_HANJA, kKey::Unknown);
    //CASE(VK_KANJI, kKey::Unknown); // same as VK_HANJA
    CASE(VK_ESCAPE, kKey::Unknown);
    CASE(VK_CONVERT, kKey::Unknown);
    CASE(VK_NONCONVERT, kKey::Unknown);
    CASE(VK_ACCEPT, kKey::Unknown);
    CASE(VK_MODECHANGE, kKey::Unknown);
    CASE(VK_SPACE, kKey::KeySpacebar);
    CASE(VK_PRIOR, kKey::Unknown);
    CASE(VK_NEXT, kKey::Unknown);
    CASE(VK_END, kKey::Unknown);
    CASE(VK_HOME, kKey::Unknown);
    CASE(VK_LEFT, kKey::Unknown);
    CASE(VK_UP, kKey::Unknown);
    CASE(VK_RIGHT, kKey::Unknown);
    CASE(VK_DOWN, kKey::Unknown);
    CASE(VK_SELECT, kKey::Unknown);
    CASE(VK_PRINT, kKey::Unknown);
    CASE(VK_EXECUTE, kKey::Unknown);
    CASE(VK_SNAPSHOT, kKey::Unknown);
    CASE(VK_INSERT, kKey::Unknown);
    CASE(VK_DELETE, kKey::KeyDel);
    CASE(VK_HELP, kKey::Unknown);
    CASE('0', kKey::Key0);
    CASE('1', kKey::Key1);
    CASE('2', kKey::Key2);
    CASE('3', kKey::Key3);
    CASE('4', kKey::Key4);
    CASE('5', kKey::Key5);
    CASE('6', kKey::Key6);
    CASE('7', kKey::Key7);
    CASE('8', kKey::Key8);
    CASE('9', kKey::Key9);
    CASE('A', kKey::KeyA);
    CASE('B', kKey::KeyB);
    CASE('C', kKey::KeyC);
    CASE('D', kKey::KeyD);
    CASE('E', kKey::KeyE);
    CASE('F', kKey::KeyF);
    CASE('G', kKey::KeyG);
    CASE('H', kKey::KeyH);
    CASE('I', kKey::KeyI);
    CASE('J', kKey::KeyJ);
    CASE('K', kKey::KeyK);
    CASE('L', kKey::KeyL);
    CASE('M', kKey::KeyM);
    CASE('N', kKey::KeyN);
    CASE('O', kKey::KeyO);
    CASE('P', kKey::KeyP);
    CASE('Q', kKey::KeyQ);
    CASE('R', kKey::KeyR);
    CASE('S', kKey::KeyS);
    CASE('T', kKey::KeyT);
    CASE('U', kKey::KeyU);
    CASE('V', kKey::KeyV);
    CASE('W', kKey::KeyW);
    CASE('X', kKey::KeyX);
    CASE('Y', kKey::KeyY);
    CASE('Z', kKey::KeyZ);
    CASE(VK_LWIN, kKey::Unknown);
    CASE(VK_RWIN, kKey::Unknown);
    CASE(VK_APPS, kKey::Unknown);
    CASE(VK_SLEEP, kKey::Unknown);
    CASE(VK_NUMPAD0, kKey::Unknown);
    CASE(VK_NUMPAD1, kKey::Unknown);
    CASE(VK_NUMPAD2, kKey::Unknown);
    CASE(VK_NUMPAD3, kKey::Unknown);
    CASE(VK_NUMPAD4, kKey::Unknown);
    CASE(VK_NUMPAD5, kKey::Unknown);
    CASE(VK_NUMPAD6, kKey::Unknown);
    CASE(VK_NUMPAD7, kKey::Unknown);
    CASE(VK_NUMPAD8, kKey::Unknown);
    CASE(VK_NUMPAD9, kKey::Unknown);
    CASE(VK_MULTIPLY, kKey::Unknown);
    CASE(VK_ADD, kKey::Unknown);
    CASE(VK_SEPARATOR, kKey::Unknown);
    CASE(VK_SUBTRACT, kKey::Unknown);
    CASE(VK_DECIMAL, kKey::Unknown);
    CASE(VK_DIVIDE, kKey::Unknown);
    CASE(VK_F1, kKey::KeyF1);
    CASE(VK_F2, kKey::KeyF2);
    CASE(VK_F3, kKey::KeyF3);
    CASE(VK_F4, kKey::KeyF4);
    CASE(VK_F5, kKey::KeyF5);
    CASE(VK_F6, kKey::KeyF6);
    CASE(VK_F7, kKey::KeyF7);
    CASE(VK_F8, kKey::KeyF8);
    CASE(VK_F9, kKey::KeyF9);
    CASE(VK_F10, kKey::KeyF10);
    CASE(VK_F11, kKey::KeyF11);
    CASE(VK_F12, kKey::KeyF12);
    CASE(VK_F13, kKey::KeyF13);
    CASE(VK_F14, kKey::KeyF14);
    CASE(VK_F15, kKey::KeyF15);
    CASE(VK_F16, kKey::KeyF16);
    CASE(VK_F17, kKey::KeyF17);
    CASE(VK_F18, kKey::KeyF18);
    CASE(VK_F19, kKey::KeyF19);
    CASE(VK_F20, kKey::KeyF20);
    CASE(VK_F21, kKey::KeyF21);
    CASE(VK_F22, kKey::KeyF22);
    CASE(VK_F23, kKey::KeyF23);
    CASE(VK_F24, kKey::KeyF24);
    CASE(VK_NUMLOCK, kKey::Unknown);
    CASE(VK_SCROLL, kKey::Unknown);
    //CASE(VK_OEM_NEC_EQUAL, kKey::Unknown); // same as VK_OEM_FJ_JISHO
    CASE(VK_OEM_FJ_JISHO, kKey::Unknown);
    CASE(VK_OEM_FJ_MASSHOU, kKey::Unknown);
    CASE(VK_OEM_FJ_TOUROKU, kKey::Unknown);
    CASE(VK_OEM_FJ_LOYA, kKey::Unknown);
    CASE(VK_OEM_FJ_ROYA, kKey::Unknown);
    CASE(VK_LSHIFT, kKey::Unknown);
    CASE(VK_RSHIFT, kKey::Unknown);
    CASE(VK_LCONTROL, kKey::Unknown);
    CASE(VK_RCONTROL, kKey::Unknown);
    CASE(VK_LMENU, kKey::Unknown);
    CASE(VK_RMENU, kKey::Unknown);
    CASE(VK_BROWSER_BACK, kKey::Unknown);
    CASE(VK_BROWSER_FORWARD, kKey::Unknown);
    CASE(VK_BROWSER_REFRESH, kKey::Unknown);
    CASE(VK_BROWSER_STOP, kKey::Unknown);
    CASE(VK_BROWSER_SEARCH, kKey::Unknown);
    CASE(VK_BROWSER_FAVORITES, kKey::Unknown);
    CASE(VK_BROWSER_HOME, kKey::Unknown);
    CASE(VK_VOLUME_MUTE, kKey::Unknown);
    CASE(VK_VOLUME_DOWN, kKey::Unknown);
    CASE(VK_VOLUME_UP, kKey::Unknown);
    CASE(VK_MEDIA_NEXT_TRACK, kKey::Unknown);
    CASE(VK_MEDIA_PREV_TRACK, kKey::Unknown);
    CASE(VK_MEDIA_STOP, kKey::Unknown);
    CASE(VK_MEDIA_PLAY_PAUSE, kKey::Unknown);
    CASE(VK_LAUNCH_MAIL, kKey::Unknown);
    CASE(VK_LAUNCH_MEDIA_SELECT, kKey::Unknown);
    CASE(VK_LAUNCH_APP1, kKey::Unknown);
    CASE(VK_LAUNCH_APP2, kKey::Unknown);
    CASE(VK_OEM_1, kKey::Unknown);
    CASE(VK_OEM_PLUS, kKey::Unknown);
    CASE(VK_OEM_COMMA, kKey::Unknown);
    CASE(VK_OEM_MINUS, kKey::Unknown);
    CASE(VK_OEM_PERIOD, kKey::Unknown);
    CASE(VK_OEM_2, kKey::Unknown);
    CASE(VK_OEM_3, kKey::Unknown);
    CASE(VK_OEM_4, kKey::Unknown);
    CASE(VK_OEM_5, kKey::Unknown);
    CASE(VK_OEM_6, kKey::Unknown);
    CASE(VK_OEM_7, kKey::Unknown);
    CASE(VK_OEM_8, kKey::Unknown);
    CASE(VK_OEM_AX, kKey::Unknown);
    CASE(VK_OEM_102, kKey::Unknown);
    CASE(VK_ICO_HELP, kKey::Unknown);
    CASE(VK_ICO_00, kKey::Unknown);
    CASE(VK_PROCESSKEY, kKey::Unknown);
    CASE(VK_ICO_CLEAR, kKey::Unknown);
    CASE(VK_PACKET, kKey::Unknown);
    CASE(VK_OEM_RESET, kKey::Unknown);
    CASE(VK_OEM_JUMP, kKey::Unknown);
    CASE(VK_OEM_PA1, kKey::Unknown);
    CASE(VK_OEM_PA2, kKey::Unknown);
    CASE(VK_OEM_PA3, kKey::Unknown);
    CASE(VK_OEM_WSCTRL, kKey::Unknown);
    CASE(VK_OEM_CUSEL, kKey::Unknown);
    CASE(VK_OEM_ATTN, kKey::Unknown);
    CASE(VK_OEM_FINISH, kKey::Unknown);
    CASE(VK_OEM_COPY, kKey::Unknown);
    CASE(VK_OEM_AUTO, kKey::Unknown);
    CASE(VK_OEM_ENLW, kKey::Unknown);
    CASE(VK_OEM_BACKTAB, kKey::Unknown);
    CASE(VK_ATTN, kKey::Unknown);
    CASE(VK_CRSEL, kKey::Unknown);
    CASE(VK_EXSEL, kKey::Unknown);
    CASE(VK_EREOF, kKey::Unknown);
    CASE(VK_PLAY, kKey::Unknown);
    CASE(VK_ZOOM, kKey::Unknown);
    CASE(VK_NONAME, kKey::Unknown);
    CASE(VK_PA1, kKey::Unknown);
    CASE(VK_OEM_CLEAR, kKey::Unknown);
    default:
        return kKey::Unknown;
    }
}
#elif __ANDROID__
inline kKey convert_key(int key)
{
    switch (key)
    {
    CASE(AKEYCODE_UNKNOWN, kKey::Unknown);
    CASE(AKEYCODE_SOFT_LEFT, kKey::Unknown);
    CASE(AKEYCODE_SOFT_RIGHT, kKey::Unknown);
    CASE(AKEYCODE_HOME, kKey::AndroidHome);
    CASE(AKEYCODE_BACK, kKey::AndroidBack);
    CASE(AKEYCODE_CALL, kKey::Unknown);
    CASE(AKEYCODE_ENDCALL, kKey::Unknown);
    CASE(AKEYCODE_0, kKey::Unknown);
    CASE(AKEYCODE_1, kKey::Unknown);
    CASE(AKEYCODE_2, kKey::Unknown);
    CASE(AKEYCODE_3, kKey::Unknown);
    CASE(AKEYCODE_4, kKey::Unknown);
    CASE(AKEYCODE_5, kKey::Unknown);
    CASE(AKEYCODE_6, kKey::Unknown);
    CASE(AKEYCODE_7, kKey::Unknown);
    CASE(AKEYCODE_8, kKey::Unknown);
    CASE(AKEYCODE_9, kKey::Unknown);
    CASE(AKEYCODE_STAR, kKey::Unknown);
    CASE(AKEYCODE_POUND, kKey::Unknown);
    CASE(AKEYCODE_DPAD_UP, kKey::Unknown);
    CASE(AKEYCODE_DPAD_DOWN, kKey::Unknown);
    CASE(AKEYCODE_DPAD_LEFT, kKey::Unknown);
    CASE(AKEYCODE_DPAD_RIGHT, kKey::Unknown);
    CASE(AKEYCODE_DPAD_CENTER, kKey::Unknown);
    CASE(AKEYCODE_VOLUME_UP, kKey::AndroidVolumeUp);
    CASE(AKEYCODE_VOLUME_DOWN, kKey::AndroidVolumeDown);
    CASE(AKEYCODE_POWER, kKey::Unknown);
    CASE(AKEYCODE_CAMERA, kKey::Unknown);
    CASE(AKEYCODE_CLEAR, kKey::Unknown);
    CASE(AKEYCODE_A, kKey::Unknown);
    CASE(AKEYCODE_B, kKey::Unknown);
    CASE(AKEYCODE_C, kKey::Unknown);
    CASE(AKEYCODE_D, kKey::Unknown);
    CASE(AKEYCODE_E, kKey::Unknown);
    CASE(AKEYCODE_F, kKey::Unknown);
    CASE(AKEYCODE_G, kKey::Unknown);
    CASE(AKEYCODE_H, kKey::Unknown);
    CASE(AKEYCODE_I, kKey::Unknown);
    CASE(AKEYCODE_J, kKey::Unknown);
    CASE(AKEYCODE_K, kKey::Unknown);
    CASE(AKEYCODE_L, kKey::Unknown);
    CASE(AKEYCODE_M, kKey::Unknown);
    CASE(AKEYCODE_N, kKey::Unknown);
    CASE(AKEYCODE_O, kKey::Unknown);
    CASE(AKEYCODE_P, kKey::Unknown);
    CASE(AKEYCODE_Q, kKey::Unknown);
    CASE(AKEYCODE_R, kKey::Unknown);
    CASE(AKEYCODE_S, kKey::Unknown);
    CASE(AKEYCODE_T, kKey::Unknown);
    CASE(AKEYCODE_U, kKey::Unknown);
    CASE(AKEYCODE_V, kKey::Unknown);
    CASE(AKEYCODE_W, kKey::Unknown);
    CASE(AKEYCODE_X, kKey::Unknown);
    CASE(AKEYCODE_Y, kKey::Unknown);
    CASE(AKEYCODE_Z, kKey::Unknown);
    CASE(AKEYCODE_COMMA, kKey::Unknown);
    CASE(AKEYCODE_PERIOD, kKey::Unknown);
    CASE(AKEYCODE_ALT_LEFT, kKey::Unknown);
    CASE(AKEYCODE_ALT_RIGHT, kKey::Unknown);
    CASE(AKEYCODE_SHIFT_LEFT, kKey::Unknown);
    CASE(AKEYCODE_SHIFT_RIGHT, kKey::Unknown);
    CASE(AKEYCODE_TAB, kKey::Unknown);
    CASE(AKEYCODE_SPACE, kKey::Unknown);
    CASE(AKEYCODE_SYM, kKey::Unknown);
    CASE(AKEYCODE_EXPLORER, kKey::Unknown);
    CASE(AKEYCODE_ENVELOPE, kKey::Unknown);
    CASE(AKEYCODE_ENTER, kKey::KeyEnter);
    CASE(AKEYCODE_DEL, kKey::KeyBackspace);
    CASE(AKEYCODE_GRAVE, kKey::Unknown);
    CASE(AKEYCODE_MINUS, kKey::Unknown);
    CASE(AKEYCODE_EQUALS, kKey::Unknown);
    CASE(AKEYCODE_LEFT_BRACKET, kKey::Unknown);
    CASE(AKEYCODE_RIGHT_BRACKET, kKey::Unknown);
    CASE(AKEYCODE_BACKSLASH, kKey::Unknown);
    CASE(AKEYCODE_SEMICOLON, kKey::Unknown);
    CASE(AKEYCODE_APOSTROPHE, kKey::Unknown);
    CASE(AKEYCODE_SLASH, kKey::Unknown);
    CASE(AKEYCODE_AT, kKey::Unknown);
    CASE(AKEYCODE_NUM, kKey::Unknown);
    CASE(AKEYCODE_HEADSETHOOK, kKey::Unknown);
    CASE(AKEYCODE_FOCUS, kKey::Unknown);
    CASE(AKEYCODE_PLUS, kKey::Unknown);
    CASE(AKEYCODE_MENU, kKey::Unknown);
    CASE(AKEYCODE_NOTIFICATION, kKey::Unknown);
    CASE(AKEYCODE_SEARCH, kKey::Unknown);
    CASE(AKEYCODE_MEDIA_PLAY_PAUSE, kKey::Unknown);
    CASE(AKEYCODE_MEDIA_STOP, kKey::Unknown);
    CASE(AKEYCODE_MEDIA_NEXT, kKey::Unknown);
    CASE(AKEYCODE_MEDIA_PREVIOUS, kKey::Unknown);
    CASE(AKEYCODE_MEDIA_REWIND, kKey::Unknown);
    CASE(AKEYCODE_MEDIA_FAST_FORWARD, kKey::Unknown);
    CASE(AKEYCODE_MUTE, kKey::Unknown);
    CASE(AKEYCODE_PAGE_UP, kKey::Unknown);
    CASE(AKEYCODE_PAGE_DOWN, kKey::Unknown);
    CASE(AKEYCODE_PICTSYMBOLS, kKey::Unknown);
    CASE(AKEYCODE_SWITCH_CHARSET, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_A, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_B, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_C, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_X, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_Y, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_Z, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_L1, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_R1, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_L2, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_R2, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_THUMBL, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_THUMBR, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_START, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_SELECT, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_MODE, kKey::Unknown);
    CASE(AKEYCODE_ESCAPE, kKey::Unknown);
    CASE(AKEYCODE_FORWARD_DEL, kKey::Unknown);
    CASE(AKEYCODE_CTRL_LEFT, kKey::Unknown);
    CASE(AKEYCODE_CTRL_RIGHT, kKey::Unknown);
    CASE(AKEYCODE_CAPS_LOCK, kKey::Unknown);
    CASE(AKEYCODE_SCROLL_LOCK, kKey::Unknown);
    CASE(AKEYCODE_META_LEFT, kKey::Unknown);
    CASE(AKEYCODE_META_RIGHT, kKey::Unknown);
    CASE(AKEYCODE_FUNCTION, kKey::Unknown);
    CASE(AKEYCODE_SYSRQ, kKey::Unknown);
    CASE(AKEYCODE_BREAK, kKey::Unknown);
    CASE(AKEYCODE_MOVE_HOME, kKey::Unknown);
    CASE(AKEYCODE_MOVE_END, kKey::Unknown);
    CASE(AKEYCODE_INSERT, kKey::Unknown);
    CASE(AKEYCODE_FORWARD, kKey::Unknown);
    CASE(AKEYCODE_MEDIA_PLAY, kKey::Unknown);
    CASE(AKEYCODE_MEDIA_PAUSE, kKey::Unknown);
    CASE(AKEYCODE_MEDIA_CLOSE, kKey::Unknown);
    CASE(AKEYCODE_MEDIA_EJECT, kKey::Unknown);
    CASE(AKEYCODE_MEDIA_RECORD, kKey::Unknown);
    CASE(AKEYCODE_F1, kKey::Unknown);
    CASE(AKEYCODE_F2, kKey::Unknown);
    CASE(AKEYCODE_F3, kKey::Unknown);
    CASE(AKEYCODE_F4, kKey::Unknown);
    CASE(AKEYCODE_F5, kKey::Unknown);
    CASE(AKEYCODE_F6, kKey::Unknown);
    CASE(AKEYCODE_F7, kKey::Unknown);
    CASE(AKEYCODE_F8, kKey::Unknown);
    CASE(AKEYCODE_F9, kKey::Unknown);
    CASE(AKEYCODE_F10, kKey::Unknown);
    CASE(AKEYCODE_F11, kKey::Unknown);
    CASE(AKEYCODE_F12, kKey::Unknown);
    CASE(AKEYCODE_NUM_LOCK, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_0, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_1, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_2, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_3, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_4, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_5, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_6, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_7, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_8, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_9, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_DIVIDE, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_MULTIPLY, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_SUBTRACT, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_ADD, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_DOT, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_COMMA, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_ENTER, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_EQUALS, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_LEFT_PAREN, kKey::Unknown);
    CASE(AKEYCODE_NUMPAD_RIGHT_PAREN, kKey::Unknown);
    CASE(AKEYCODE_VOLUME_MUTE, kKey::Unknown);
    CASE(AKEYCODE_INFO, kKey::Unknown);
    CASE(AKEYCODE_CHANNEL_UP, kKey::Unknown);
    CASE(AKEYCODE_CHANNEL_DOWN, kKey::Unknown);
    CASE(AKEYCODE_ZOOM_IN, kKey::Unknown);
    CASE(AKEYCODE_ZOOM_OUT, kKey::Unknown);
    CASE(AKEYCODE_TV, kKey::Unknown);
    CASE(AKEYCODE_WINDOW, kKey::Unknown);
    CASE(AKEYCODE_GUIDE, kKey::Unknown);
    CASE(AKEYCODE_DVR, kKey::Unknown);
    CASE(AKEYCODE_BOOKMARK, kKey::Unknown);
    CASE(AKEYCODE_CAPTIONS, kKey::Unknown);
    CASE(AKEYCODE_SETTINGS, kKey::Unknown);
    CASE(AKEYCODE_TV_POWER, kKey::Unknown);
    CASE(AKEYCODE_TV_INPUT, kKey::Unknown);
    CASE(AKEYCODE_STB_POWER, kKey::Unknown);
    CASE(AKEYCODE_STB_INPUT, kKey::Unknown);
    CASE(AKEYCODE_AVR_POWER, kKey::Unknown);
    CASE(AKEYCODE_AVR_INPUT, kKey::Unknown);
    CASE(AKEYCODE_PROG_RED, kKey::Unknown);
    CASE(AKEYCODE_PROG_GREEN, kKey::Unknown);
    CASE(AKEYCODE_PROG_YELLOW, kKey::Unknown);
    CASE(AKEYCODE_PROG_BLUE, kKey::Unknown);
    CASE(AKEYCODE_APP_SWITCH, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_1, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_2, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_3, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_4, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_5, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_6, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_7, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_8, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_9, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_10, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_11, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_12, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_13, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_14, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_15, kKey::Unknown);
    CASE(AKEYCODE_BUTTON_16, kKey::Unknown);
    CASE(AKEYCODE_LANGUAGE_SWITCH, kKey::Unknown);
    CASE(AKEYCODE_MANNER_MODE, kKey::Unknown);
    CASE(AKEYCODE_3D_MODE, kKey::Unknown);
    CASE(AKEYCODE_CONTACTS, kKey::Unknown);
    CASE(AKEYCODE_CALENDAR, kKey::Unknown);
    CASE(AKEYCODE_MUSIC, kKey::Unknown);
    CASE(AKEYCODE_CALCULATOR, kKey::Unknown);
    CASE(AKEYCODE_ZENKAKU_HANKAKU, kKey::Unknown);
    CASE(AKEYCODE_EISU, kKey::Unknown);
    CASE(AKEYCODE_MUHENKAN, kKey::Unknown);
    CASE(AKEYCODE_HENKAN, kKey::Unknown);
    CASE(AKEYCODE_KATAKANA_HIRAGANA, kKey::Unknown);
    CASE(AKEYCODE_YEN, kKey::Unknown);
    CASE(AKEYCODE_RO, kKey::Unknown);
    CASE(AKEYCODE_KANA, kKey::Unknown);
    CASE(AKEYCODE_ASSIST, kKey::Unknown);
    CASE(AKEYCODE_BRIGHTNESS_DOWN, kKey::Unknown);
    CASE(AKEYCODE_BRIGHTNESS_UP, kKey::Unknown);
    CASE(AKEYCODE_MEDIA_AUDIO_TRACK, kKey::Unknown);
    default:
        return kKey::Unknown;
    }
}
#elif __WEB__
inline kKey convert_key(int key)
{
    switch (key)
    {
    CASE(GLFW_KEY_UNKNOWN, kKey::Unknown);
    CASE(GLFW_KEY_SPACE, kKey::KeySpacebar);
    CASE(GLFW_KEY_APOSTROPHE, kKey::Unknown);
    CASE(GLFW_KEY_COMMA, kKey::Unknown);
    CASE(GLFW_KEY_MINUS, kKey::Unknown);
    CASE(GLFW_KEY_PERIOD, kKey::Unknown);
    CASE(GLFW_KEY_SLASH, kKey::Unknown);
    CASE(GLFW_KEY_0, kKey::Key0);
    CASE(GLFW_KEY_1, kKey::Key1);
    CASE(GLFW_KEY_2, kKey::Key2);
    CASE(GLFW_KEY_3, kKey::Key3);
    CASE(GLFW_KEY_4, kKey::Key4);
    CASE(GLFW_KEY_5, kKey::Key5);
    CASE(GLFW_KEY_6, kKey::Key6);
    CASE(GLFW_KEY_7, kKey::Key7);
    CASE(GLFW_KEY_8, kKey::Key8);
    CASE(GLFW_KEY_9, kKey::Key9);
    CASE(GLFW_KEY_SEMICOLON, kKey::Unknown);
    CASE(GLFW_KEY_EQUAL, kKey::Unknown);
    CASE(GLFW_KEY_A, kKey::KeyA);
    CASE(GLFW_KEY_B, kKey::KeyB);
    CASE(GLFW_KEY_C, kKey::KeyC);
    CASE(GLFW_KEY_D, kKey::KeyD);
    CASE(GLFW_KEY_E, kKey::KeyE);
    CASE(GLFW_KEY_F, kKey::KeyF);
    CASE(GLFW_KEY_G, kKey::KeyG);
    CASE(GLFW_KEY_H, kKey::KeyH);
    CASE(GLFW_KEY_I, kKey::KeyI);
    CASE(GLFW_KEY_J, kKey::KeyJ);
    CASE(GLFW_KEY_K, kKey::KeyK);
    CASE(GLFW_KEY_L, kKey::KeyL);
    CASE(GLFW_KEY_M, kKey::KeyM);
    CASE(GLFW_KEY_N, kKey::KeyN);
    CASE(GLFW_KEY_O, kKey::KeyO);
    CASE(GLFW_KEY_P, kKey::KeyP);
    CASE(GLFW_KEY_Q, kKey::KeyQ);
    CASE(GLFW_KEY_R, kKey::KeyR);
    CASE(GLFW_KEY_S, kKey::KeyS);
    CASE(GLFW_KEY_T, kKey::KeyT);
    CASE(GLFW_KEY_U, kKey::KeyU);
    CASE(GLFW_KEY_V, kKey::KeyV);
    CASE(GLFW_KEY_W, kKey::KeyW);
    CASE(GLFW_KEY_X, kKey::KeyX);
    CASE(GLFW_KEY_Y, kKey::KeyY);
    CASE(GLFW_KEY_Z, kKey::KeyZ);
    CASE(GLFW_KEY_LEFT_BRACKET, kKey::Unknown);
    CASE(GLFW_KEY_BACKSLASH, kKey::Unknown);
    CASE(GLFW_KEY_RIGHT_BRACKET, kKey::Unknown);
    CASE(GLFW_KEY_GRAVE_ACCENT, kKey::Unknown);
    CASE(GLFW_KEY_WORLD_1, kKey::Unknown);
    CASE(GLFW_KEY_WORLD_2, kKey::Unknown);
    CASE(GLFW_KEY_ESCAPE, kKey::Unknown);
    CASE(GLFW_KEY_ENTER, kKey::Unknown);
    CASE(GLFW_KEY_TAB, kKey::KeyTab);
    CASE(GLFW_KEY_BACKSPACE, kKey::KeyBackspace);
    CASE(GLFW_KEY_INSERT, kKey::Unknown);
    CASE(GLFW_KEY_DELETE, kKey::KeyDel);
    CASE(GLFW_KEY_RIGHT, kKey::Unknown);
    CASE(GLFW_KEY_LEFT, kKey::Unknown);
    CASE(GLFW_KEY_DOWN, kKey::Unknown);
    CASE(GLFW_KEY_UP, kKey::Unknown);
    CASE(GLFW_KEY_PAGE_UP, kKey::Unknown);
    CASE(GLFW_KEY_PAGE_DOWN, kKey::Unknown);
    CASE(GLFW_KEY_HOME, kKey::Unknown);
    CASE(GLFW_KEY_END, kKey::Unknown);
    CASE(GLFW_KEY_CAPS_LOCK, kKey::Unknown);
    CASE(GLFW_KEY_SCROLL_LOCK, kKey::Unknown);
    CASE(GLFW_KEY_NUM_LOCK, kKey::Unknown);
    CASE(GLFW_KEY_PRINT_SCREEN, kKey::Unknown);
    CASE(GLFW_KEY_PAUSE, kKey::Unknown);
    CASE(GLFW_KEY_F1, kKey::Unknown);
    CASE(GLFW_KEY_F2, kKey::Unknown);
    CASE(GLFW_KEY_F3, kKey::Unknown);
    CASE(GLFW_KEY_F4, kKey::Unknown);
    CASE(GLFW_KEY_F5, kKey::Unknown);
    CASE(GLFW_KEY_F6, kKey::Unknown);
    CASE(GLFW_KEY_F7, kKey::Unknown);
    CASE(GLFW_KEY_F8, kKey::Unknown);
    CASE(GLFW_KEY_F9, kKey::Unknown);
    CASE(GLFW_KEY_F10, kKey::Unknown);
    CASE(GLFW_KEY_F11, kKey::Unknown);
    CASE(GLFW_KEY_F12, kKey::Unknown);
    CASE(GLFW_KEY_F13, kKey::Unknown);
    CASE(GLFW_KEY_F14, kKey::Unknown);
    CASE(GLFW_KEY_F15, kKey::Unknown);
    CASE(GLFW_KEY_F16, kKey::Unknown);
    CASE(GLFW_KEY_F17, kKey::Unknown);
    CASE(GLFW_KEY_F18, kKey::Unknown);
    CASE(GLFW_KEY_F19, kKey::Unknown);
    CASE(GLFW_KEY_F20, kKey::Unknown);
    CASE(GLFW_KEY_F21, kKey::Unknown);
    CASE(GLFW_KEY_F22, kKey::Unknown);
    CASE(GLFW_KEY_F23, kKey::Unknown);
    CASE(GLFW_KEY_F24, kKey::Unknown);
    CASE(GLFW_KEY_F25, kKey::Unknown);
    CASE(GLFW_KEY_KP_0, kKey::Unknown);
    CASE(GLFW_KEY_KP_1, kKey::Unknown);
    CASE(GLFW_KEY_KP_2, kKey::Unknown);
    CASE(GLFW_KEY_KP_3, kKey::Unknown);
    CASE(GLFW_KEY_KP_4, kKey::Unknown);
    CASE(GLFW_KEY_KP_5, kKey::Unknown);
    CASE(GLFW_KEY_KP_6, kKey::Unknown);
    CASE(GLFW_KEY_KP_7, kKey::Unknown);
    CASE(GLFW_KEY_KP_8, kKey::Unknown);
    CASE(GLFW_KEY_KP_9, kKey::Unknown);
    CASE(GLFW_KEY_KP_DECIMAL, kKey::Unknown);
    CASE(GLFW_KEY_KP_DIVIDE, kKey::Unknown);
    CASE(GLFW_KEY_KP_MULTIPLY, kKey::Unknown);
    CASE(GLFW_KEY_KP_SUBTRACT, kKey::Unknown);
    CASE(GLFW_KEY_KP_ADD, kKey::Unknown);
    CASE(GLFW_KEY_KP_ENTER, kKey::Unknown);
    CASE(GLFW_KEY_KP_EQUAL, kKey::Unknown);
    CASE(GLFW_KEY_LEFT_SHIFT, kKey::Unknown);
    CASE(GLFW_KEY_LEFT_CONTROL, kKey::Unknown);
    CASE(GLFW_KEY_LEFT_ALT, kKey::Unknown);
    CASE(GLFW_KEY_LEFT_SUPER, kKey::Unknown);
    CASE(GLFW_KEY_RIGHT_SHIFT, kKey::Unknown);
    CASE(GLFW_KEY_RIGHT_CONTROL, kKey::Unknown);
    CASE(GLFW_KEY_RIGHT_ALT, kKey::Unknown);
    CASE(GLFW_KEY_RIGHT_SUPER, kKey::Unknown);
    CASE(GLFW_KEY_MENU, kKey::Unknown);
    default:
        return kKey::Unknown;
    }
}
//#elif __XXX__
//kKey convert_key(int key)
//{
//    switch (key)
//    {
//    default:
//        return kKey::Unknown;
//    }
//}
#endif
#undef CASE
